searchNodes=[{"doc":"Command-line interface to Tracex collector","ref":"Mix.Tasks.Tracex.Collect.html","title":"Mix.Tasks.Tracex.Collect","type":"task"},{"doc":"Compiles project, collects compiler traces, builds project&#39;s metadata and dumps to disk in form of manifest file. Command line options manifest_path - path to manifest file, defaults to _build/{Mix.env}/lib/tracex/.mix/tracex.collect classifier - path to a file defining custom classifier module Multiple classifiers can be specified as: mix tracex.collect --classifier one.ex --classifier two.ex See Tracex.Classifier for information about writing custom classifiers.","ref":"Mix.Tasks.Tracex.Collect.html#run/1","title":"Mix.Tasks.Tracex.Collect.run/1","type":"function"},{"doc":"Tracex is a tool for static analysis of mix projects It builds upon compiler tracing introduced in Elixir 1.10, simplifying collection of traces and turning them into valuable insights. Tracex collects traces emitted by Elixir compiler and performs some basic data extraction and classification. The result, together with project&#39;s metadata built along the way, is available to the developer for further analysis. Tracex automatically recognizes some common types of modules present in mix projects, like Ecto schemas or Phoenix controllers and views. Additionally it supports attaching custom classifiers that are specific to your project in order to collect extra information that may prove helpful in actual analysis. Elixir compiler emits a lot of traces. For practical reasons tracex collets only ones that are local to your project. It means that any traces of interactions of your project&#39;s code with Elixir&#39;s core modules or external libraries are discarded.","ref":"Tracex.html","title":"Tracex","type":"module"},{"doc":"Compile a project and collect compiler traces for later analysis Project&#39;s metadata is built along the way and written to disk together with collected traces in manifest file. This enables the developer to load it into iex console and play with it. Options manifest_path - path to manifest file, defaults to _build/{Mix.env}/lib/tracex/.mix/tracex custom_classifiers - list of project-specific classifier modules","ref":"Tracex.html#compile_project/1","title":"Tracex.compile_project/1","type":"function"},{"doc":"Returns module insights See Tracex.Insights for more information.","ref":"Tracex.html#insights/2","title":"Tracex.insights/2","type":"function"},{"doc":"Loads tracex manifest file from disk","ref":"Tracex.html#load_from_manifest/1","title":"Tracex.load_from_manifest/1","type":"function"},{"doc":"Default classifier that generates annotations for common modules, that are being picked up by the collector. The following annotations are currently supported: {:track, module, file} - tracks module definition in given source file and enables trace collection for that module (collector does not collect traces for untracked modules) {:tag, module, tag} - adds tag to module&#39;s tags {:extra, module, key, value} - adds key/value pair to module&#39;s extra attributes Consult README for information about providing custom classifiers for your project.","ref":"Tracex.Classifier.html","title":"Tracex.Classifier","type":"module"},{"doc":"Sets up tracking and generates module annotations for module types common among mix projects, (e.g. ecto schemas, phoenix controllers, views routers and channels).","ref":"Tracex.Classifier.html#classify/1","title":"Tracex.Classifier.classify/1","type":"function"},{"doc":"Module providing insights on project&#39;s modules by analyzing traces collected during its compilation","ref":"Tracex.Insights.html","title":"Tracex.Insights","type":"module"},{"doc":"Returns insights on given module or modules If you need insights on multiple modules it&#39;s faster to pass them as a list to this function instead of calling it for each module separately.","ref":"Tracex.Insights.html#module/2","title":"Tracex.Insights.module/2","type":"function"},{"doc":"Wrapper for project metadata Keeps information about project&#39;s source files and defined modules. Project modules can be tagged or have extra attributes assigned.","ref":"Tracex.Project.html","title":"Tracex.Project","type":"module"},{"doc":"Add an extra attribute to a module for future inspection","ref":"Tracex.Project.html#add_extra/4","title":"Tracex.Project.add_extra/4","type":"function"},{"doc":"Add module to the project","ref":"Tracex.Project.html#add_module/2","title":"Tracex.Project.add_module/2","type":"function"},{"doc":"Builds project struct from mix config","ref":"Tracex.Project.html#build_from_mix_project/1","title":"Tracex.Project.build_from_mix_project/1","type":"function"},{"doc":"Returns project module","ref":"Tracex.Project.html#get_module/2","title":"Tracex.Project.get_module/2","type":"function"},{"doc":"Returns the list of modules tracked for project, optionally filtered Options: tags - list of tags to filter modules by (at least one tag must match)","ref":"Tracex.Project.html#get_modules/2","title":"Tracex.Project.get_modules/2","type":"function"},{"doc":"Tags a module with tag for future filtering","ref":"Tracex.Project.html#tag_module/3","title":"Tracex.Project.tag_module/3","type":"function"},{"doc":"","ref":"Tracex.Project.html#t:project_module/0","title":"Tracex.Project.project_module/0","type":"type"},{"doc":"","ref":"Tracex.Project.html#t:t/0","title":"Tracex.Project.t/0","type":"type"},{"doc":"","ref":"Tracex.Project.Module.html","title":"Tracex.Project.Module","type":"module"},{"doc":"","ref":"Tracex.Project.Module.html#t:t/0","title":"Tracex.Project.Module.t/0","type":"type"},{"doc":"Collection of helpers to extract data from compiler traces Compiler traces encapsulate events happening in certain environment. The module originating an event is considered an outbound module, the module on the receiving end is considered an inbound module. For example, consider a trace emitted when module A imports a function from module B. A is denoted as outbound and B as inbound. Traces of local function or marco calls naturally have the same module as both inbound and outbound. Note that inbound/outbound notions translate directly to direction of the edge between the two modules involved in project&#39;s module dependency graph.","ref":"Tracex.Trace.html","title":"Tracex.Trace","type":"module"},{"doc":"Returns function name and arity formatted as function/arity for remote call traces","ref":"Tracex.Trace.html#event_func_and_arity/1","title":"Tracex.Trace.event_func_and_arity/1","type":"function"},{"doc":"Returns location in code where a trace originates formatted as path:line Elixir compiler does not always provide a precise line number of the code in question, but rather the line of where its execution environment is defined. For example if an event originates in function&#39;s body, a line in which the function is defined is returned.","ref":"Tracex.Trace.html#event_location/1","title":"Tracex.Trace.event_location/1","type":"function"},{"doc":"Returns true if given module is on the receiving end of the traced event","ref":"Tracex.Trace.html#inbound?/2","title":"Tracex.Trace.inbound?/2","type":"function"},{"doc":"Returns trace&#39;s inbound module","ref":"Tracex.Trace.html#inbound_module/1","title":"Tracex.Trace.inbound_module/1","type":"function"},{"doc":"Returns true if trace describes using given module via use GivenModule","ref":"Tracex.Trace.html#macro_usage?/2","title":"Tracex.Trace.macro_usage?/2","type":"function"},{"doc":"Returns true if trace describes a module definition","ref":"Tracex.Trace.html#module_definition?/1","title":"Tracex.Trace.module_definition?/1","type":"function"},{"doc":"Returns true if given module is originating the traced event","ref":"Tracex.Trace.html#outbound?/2","title":"Tracex.Trace.outbound?/2","type":"function"},{"doc":"Returns trace&#39;s outbound module","ref":"Tracex.Trace.html#outbound_module/1","title":"Tracex.Trace.outbound_module/1","type":"function"},{"doc":"Returns true if trace describes a remote function or macro call","ref":"Tracex.Trace.html#remote_call?/1","title":"Tracex.Trace.remote_call?/1","type":"function"},{"doc":"","ref":"Tracex.Trace.html#t:env/0","title":"Tracex.Trace.env/0","type":"type"},{"doc":"","ref":"Tracex.Trace.html#t:event/0","title":"Tracex.Trace.event/0","type":"type"},{"doc":"","ref":"Tracex.Trace.html#t:t/0","title":"Tracex.Trace.t/0","type":"type"},{"doc":"Tracex Tracex is a tool for static analysis of mix projects. It builds upon compiler tracing introduced in Elixir 1.10, simplifying collection of traces and turning them into valuable insights. Tracex collects traces emitted by Elixir compiler and performs some basic data extraction and classification. The result, together with project&#39;s metadata built along the way, is available to the developer for further analysis. Tracex automatically recognizes some common types of modules present in mix projects, like Ecto schemas or Phoenix controllers and views. Additionally it supports attaching custom classifiers that are specific to your project in order to collect extra information that may prove helpful in actual analysis. Elixir compiler emits a lot of traces. For practical reasons tracex collets only ones that are local to your project. It means that any traces of interactions of your project&#39;s code with Elixir&#39;s core modules or external libraries are discarded.","ref":"readme.html","title":"Tracex","type":"extras"},{"doc":"Bad architectural decisions can lead to slow recompilation and negatively affect developer&#39;s workflow. Tracex was created to help me fight exactly this problem in an actual project. It aims to aid in refactoring by providing insights into project&#39;s internal structure and interactions between the modules.","ref":"readme.html#motivation","title":"Tracex - Motivation","type":"extras"},{"doc":"The package can be installed by adding tracex to your list of dependencies in mix.exs: def deps do [ {:tracex, &quot;~&gt; 0.1.0&quot;, only: :dev} ] end","ref":"readme.html#installation","title":"Tracex - Installation","type":"extras"},{"doc":"First thing is to perform trace collection during project compilation. iex&gt; {project, traces} = Tracex.compile_project() This compiles the project (with regular Elixir compiler), collects emitted traces and module information. It also dumps everything to disk in form of manifest file that can be later quickly reloaded in another iex session without recompilation. iex&gt; {project, traces} = Tracex.load_from_manifest() project struct encapsulates information about project&#39;s modules and traces is a (possibly long) list of collected compiler traces. iex&gt; project.get_module(MyApp.Model.User) %Tracex.Project.Module{ extra: %{}, file: &quot;lib/models/user.ex&quot;, name: MyApp.Model.User, tags: [:ecto_schema] } By default module information is rather basic, but with help of custom classifiers modules can be annotated with extra information that is important in the context of your project (see Classifiers section). Filtering modules by annotations Filtering by tags in built-in Tracex.Project.get_modules/2, extra annotations must be filtered manually. project |&gt; Tracex.Project.get_modules(tags: [:phoenix_controller, :phoenix_view]) |&gt; Enum.filter(fn %{extra: extra} -&gt; Map.get(extra, :context) == &quot;Users&quot; end) Module insights To get some insights into how a module is used and how it interacts with other modules in your project use Tracex.insights/2 iex&gt; Tracex.insights(traces, MyApp.Model.User) %{ inbound: [ {:remote_function, MyApp.UserView, &quot;full_name/1&quot;, &quot;web/views/user_view.ex:14&quot;}, {:alias_reference, MyApp.UserView, &quot;web/views/user_view.ex:14&quot;}, {:struct_expansion, MyApp.ReportGenerator, &quot;lib/report_generator.ex:20&quot;}, {:alias_reference, MyApp.ReportGenerator, &quot;lib/report_generator.ex:20&quot;}, ... ], outbound: [ {:imported_macro, MyApp.I18n, &quot;lib/models/user.ex:70&quot;}, {:imported_function, MyApp.Validators, &quot;lib/models/user.ex:38&quot;}, {:remote_function, MyApp.Validators, &quot;validate_password_strength/1&quot;, &quot;lib/models/user.ex:31&quot;}, ... ] } Module insights encapsulate the information provided by compiler tracers. At the very minimum you can get some idea how the module interacts with others and possibly track down dependencies contributing to extensive recompilations in your project. Classifiers Tracex is generic, it is able to extract some basic information about your project modules, but every project has its own unique characteristics, like naming conventions or usage of certain macros. Classifiers make it easy to leverage that tacit knowledge to annotate your project&#39;s modules. For example, you may want to focus your analysis on some specific classes of modules, like event handlers or query builders. Or take a broader view and group modules in contexts to analyze cross-context dependencies. By annotating modules accordingly, it will be later easier to perform actual analysis. Tracex currently supports two types of annotations: tags and extra attributes. You have already seen tags usage in the example above with MyApp.Models.User module being tagged as :ecto_schema. Tracex&#39;s built-in classifier automatically tags a module that way when it detects use of use Ecto.Schema in module&#39;s body. Analogically it is able to tag modules as :phoenix_controller, :phoenix_view, :phoenix_router or :phoenix_channel. See Tracex.Classifier for more details. As tags are supposed to be a list of atoms, extra attributes is a map to keep anything you&#39;d find useful. For example, name of a context a module is in. The only requirement for a custom classifier module is to implement classify/1 function that accepts compiler trace as argument and returns a list module annotations. defmodule MyClassifier do # import some helper functions to easily work with compiler traces # See [`Tracex.Trace`](Tracex.Trace.html) for full list import Tracex.Trace, only: [ module_definition?: 1, macro_usage?: 2, outbound_module: 2, event_location: 1 ] def classify(trace) do module = outbound_module(trace) cond do module_definition?(trace) -&gt; # annotate module with context information {:extra, module, :context, extract_context_from_module_name(module)} macro_usage?(trace, MyApp.QueryBuilder) -&gt; # assuming query builder modules in your project make use of # `use MyApp.QueryBuilder`, you can detect that using `macro_usage?/2` {:tag, module, :query_builder} String.starts_with?(event_location?(trace), &quot;web/controllers/api/v1/&quot;) -&gt; # annotate module with API version number and tag as :legacy [{:extra, module, :version, 1}, {:tag, module, :legacy}] String.starts_with?(event_location(trace), &quot;web/controllers/api/v2/&quot;) -&gt; # annotate module with API version number {:extra, module, :version, 2} String.starts_with?(event_location(trace), &quot;apps/&quot;) -&gt; # annotate module with umbrella app name {:extra, module, :umbrella_app, extract_app_from_path(event_location(trace))} true -&gt; nil end end defp extract_context_from_module_name(module) do # custom logic to map module name to context name end defp extract_app_from_path(path) do # regex-based extraction end end Note that custom classifiers should not use any code from your project because it will not be available during compilation. To use a custom classifier module you must compile it manually before supplying to Tracex.compile_project/1. iex&gt; c &quot;my_classifier.exs&quot; iex&gt; Tracex.compile_project(custom_classifiers: [MyClassifier])","ref":"readme.html#usage","title":"Tracex - Usage","type":"extras"},{"doc":"Tracex is highly experimental and completely untested. The interface is a subject to change.","ref":"readme.html#state-of-the-library","title":"Tracex - State of the library","type":"extras"},{"doc":"annotating traces by type of dependency (compile-time or runtime) they create between modules, although I&#39;m not sure it&#39;s possible to get it 100% right with the information currently provided by compiler traces support for visualizations, e.g. using hierarchical edge bundling cycle detection in module dependency graph ...","ref":"readme.html#roadmap","title":"Tracex - Roadmap","type":"extras"},{"doc":"Documentation is available at https://hexdocs.pm/tracex.","ref":"readme.html#documentation","title":"Tracex - Documentation","type":"extras"},{"doc":"MIT","ref":"readme.html#license","title":"Tracex - License","type":"extras"}]